【HAOI2015】【BZOJ4036】【洛谷P3175】按位或(Min-Max 容斥)(FMT)

BZOJ传送门

洛谷传送门


题解:

首先这种跟二进制位有关的期望题很显然就是考虑Min-Max容斥。

这道题的集合显然就是所有二进制位。

于是 E ( max ⁡ ( S ) ) = ∑ T ⊆ S ( − 1 ) ∣ T ∣ + 1 E ( min ⁡ ( T ) ) E(\max(S))=\sum_{T\subseteq S}(-1)^{|T|+1}E(\min(T)) E(max(S))=TS(1)T+1E(min(T))

显然 T T T集合中的元素期望最早时间出现就是 1 ∑ U ∩ T ! = ∅ P U \dfrac{1}{\sum\limits_{U\cap T !=\empty}P_U} UT!=PU1

我们需要求所有和一个集合交不为空的集合的 P P P之和。

转化为求所有和一个集合交为空的集合的 P P P之和,发现就是该集合补集的所有子集,直接用快速莫比乌斯变换就行了。


代码:

#include<bits/stdc++.h>
#define ll long long
#define re register
#define gc get_char
#define cs const

namespace IO{
	inline char get_char(){
		static cs int Rlen=1<<22|1;
		static char buf[Rlen],*p1,*p2;
		return (p1==p2)&&(p2=(p1=buf)+fread(buf,1,Rlen,stdin),p1==p2)?EOF:*p1++;
	}
	
	inline double getdb(){
		char c;
		while(!isdigit(c=gc()));double x=c^48;
		while(isdigit(c=gc()))x=(x*10)+(c^48);
		if(c!='.')return x;double y=1;
		while(isdigit(c=gc()))x+=(y/=10)*(c^48);
		return x;
	}
}
using namespace IO;

using std::cerr;
using std::cout;

cs int N=1<<20|1;
double a[N];
int popcount[N];
signed main(){
#ifdef zxyoi
	freopen("or.in","r",stdin);
#endif
	int len;scanf("%d",&len);len=1<<len;int ok=0;
	for(int re i=0;i<len;++i)a[i]=getdb(),popcount[i]=popcount[i>>1]^(i&1);
	for(int re i=0;i<len;++i)if(a[i]>1e-6)ok|=i;
	if(ok!=len-1)puts("INF"),exit(0);
	
	for(int re i=1;i<len;i<<=1)
	for(int re j=0;j<len;j+=i<<1)
	for(int re k=0;k<i;++k)a[i|k|j]+=a[k|j];
	
	double ans=0;
	for(int re i=1;i<len;++i){
		double val=1/(1-a[(len-1)^i]);
		popcount[i]?ans+=val:ans-=val;
	}
	printf("%.12f",ans);
	return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
这道题目还可以使用树状数组或线段树来实现,时间复杂度也为 $\mathcal{O}(n\log n)$。这里给出使用树状数组的实现代码。 解题思路: 1. 读入数据; 2. 将原数列离散化,得到一个新的数列 b; 3. 从右往左依次将 b 数列中的元素插入到树状数组中,并计算逆序对数; 4. 输出逆序对数。 代码实现: ```c++ #include <cstdio> #include <cstdlib> #include <algorithm> const int MAXN = 500005; struct Node { int val, id; bool operator<(const Node& other) const { return val < other.val; } } nodes[MAXN]; int n, a[MAXN], b[MAXN], c[MAXN]; long long ans; inline int lowbit(int x) { return x & (-x); } void update(int x, int val) { for (int i = x; i <= n; i += lowbit(i)) { c[i] += val; } } int query(int x) { int res = 0; for (int i = x; i > 0; i -= lowbit(i)) { res += c[i]; } return res; } int main() { scanf("%d", &n); for (int i = 1; i <= n; ++i) { scanf("%d", &a[i]); nodes[i] = {a[i], i}; } std::sort(nodes + 1, nodes + n + 1); int cnt = 0; for (int i = 1; i <= n; ++i) { if (i == 1 || nodes[i].val != nodes[i - 1].val) { ++cnt; } b[nodes[i].id] = cnt; } for (int i = n; i >= 1; --i) { ans += query(b[i] - 1); update(b[i], 1); } printf("%lld\n", ans); return 0; } ``` 注意事项: - 在对原数列进行离散化时,需要记录每个元素在原数列中的位置,便于后面计算逆序对数; - 设树状数组的大小为 $n$,则树状数组中的下标从 $1$ 到 $n$,而不是从 $0$ 到 $n-1$; - 在计算逆序对数时,需要查询离散化后的数列中比当前元素小的元素个数,即查询 $b_i-1$ 位置上的值; - 在插入元素时,需要将离散化后的数列的元素从右往左依次插入树状数组中,而不是从左往右。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值